#!/bin/awk -f
#
# preprocess song by-artist index by prefixing sort key to each line.
# this generates a sort key for the "album" level of the directories.
#
# sort-map comes first in the form:
#   canonical-name:sort-key
# examples:
#   artist:SORT=Name, Artist
#
# output is in form:
#   sort-key{^I}canonical-name
#

/:SORT=/ {
    split($0,a,":")
    i=index($0,"=")
    sortmap[a[1]]=substr($0,i+1)
}

/:DATE=/ {
    split($0,a,":")
    i=index($0,"=")
    sortmapdate[a[1]]=substr($0,i+1,4)
}

!/:/ && (!/\./ || /\.mp3$/) {
    canon=$1
    names=$1
    if (names ~ /\.mp3$/) {
	names=substr(names, 1, length(names)-4)
    }
    nel=split(names,a,"/");
    aa[1]=a[1]
    for (i = 2; i <= nel; i++) {
	aa[i]=aa[i-1] "/" a[i]
    }
    if (nel > 2) {
	if (sortmap[aa[nel-2]] != "") {
	    b[1]=sortmap[aa[nel-2]]
	} else {
	    b[1]=a[nel-2]
	}
	if (sortmap[aa[nel-1]] != "") {
	    b[2]=sortmap[aa[nel-1]]
	} else {
	    b[2]=a[nel-1]
	}
	if (sortmapdate[aa[nel-1]] != "") {
	    b[3]=sortmapdate[aa[nel-1]]
	} else {
	    b[3]="0000"
	}
	out=b[1] "/" b[3] b[2] "/" a[nel]
    }
    print out "	" canon
}

