#!/usr/bin/perl
#
# list the tune currently playing, ones recently played, and ones in the q.
#
# imports:
#    environment:
#    TUNEBOT_ROOT    root of tunebot installation.
#    QDIR            directory where requests and play history live.
#    BANNER_STRING   identifying string for web page titles
#    HOWMANY_TUNES   how many tunes of history to show
#
#    files:
#       $TUNEBOT_ROOT/tune.autotags
#       $TUNEBOT_ROOT/html/bodypart.html.head
#       $TUNEBOT_ROOT/html/bodypart.html.tail
#

$tunebot_root=$ENV{TUNEBOT_ROOT};
$q_directory=$ENV{QDIR};
$how_many=$ENV{HOWMANY_TUNES};
if ($how_many < 1) {
    $how_many=10;
}
$random_from_q=$ENV{RANDOM_FROM_Q};
if ($random_from_q > 0) {
    $random_from_q = 1;
} else {
    $random_from_q = 0;
}

open(AUTOTAGS, $ENV{TUNEBOT_ROOT} . "/tune.autotags");
while ($line = <AUTOTAGS>) {
    chop $line;
    $i = index($line, ":");
    $j = index($line, "=", $i);
    $file = substr($line, 0, $i);
    $tag = substr($line, $i + 1, $j - $i - 1);
    $value = substr($line, $j + 1);
    $autotags{$file, $tag} = $value;
}
close(AUTOTAGS);

sub nicetime {
    my ($a) = @_[0];
    my ($m1) = substr($a, 14, 2);
    my ($h1) = substr($a, 11, 2);
    my ($d1) = substr($a, 8, 2);
    my ($n1) = substr($a, 5, 2);
    my ($y1) = substr($a, 0, 4);
    my ($i, $m0, $h0, $d0, $n0, $y0, $i, $i, $i) = localtime(time);
    $n0++;
    $y0 += 1900;
    $i = "";
    if ($y1 != $y0) {
	$i = $y1 . "/";
	$n0 = -1;
    }
    if ($n1 != $n0 || $d1 != $d0) {
	$i = $i . $n1 . "/" . $d1 . " ";
	$d0 = -1;
    }
    my ($ap) = "am";
    if ($h1 > 11) {
	$h1 -= 12;
	$ap = "pm";
    }
    if ($h1 == 0) {
	$h1 = 12;
    }
    $i = "$i$h1:$m1 $ap";
    return $i;
}

sub lookuptag {
    my ($a) = @_[0];
    my ($i) = index($a, "\.mp3");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    my ($t) = "";
    if (open(F, $a . ".t")) {
	while ($i = <F>) {
	    chop $i;
	    if (substr($i, 0, length(@_[1])) eq @_[1]) {
		$t = substr($i, length(@_[1]));
		break;
	    }
	}
	close(F);
    } elsif (open(F, $a)) {
	while ($i = <F>) {
	    chop $i;
	    if (substr($i, 0, length(@_[1])) eq @_[1]) {
		$t = substr($i, length(@_[1]));
		break;
	    }
	}
	close(F);
    }
    return $t;
}

sub friendlytitle {
    my ($title) = lookuptag(@_, "N=");
    if ($title eq "") {
	$title = @_[0];
	$title =~ s/^.*\///;
	$title =~ s/\.mp3$//;
	$title = "<em>" . $title . "</em>";
    }
    my ($art) = lookuptag(@_, "ARTIST=");
    if ($art ne "") {
	$title = $title . " <em>- " . $art . "</em>";
    }
    my ($b) = @_;
    my ($i) = rindex($b, "/");
    if ($i >= 0) {
	$b = substr($b, 0, $i);
    }
    my ($a) = $b;
    $i = rindex($a, "/");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    $i = lookuptag($a, "N=");
    if ($i eq "") {
	$i = $a;
	$i =~ s/\/$//;
	$i =~ s/^.*\///;
    }
    $x = $autotags{$a, "H_ARTIST"};
    $y = $autotags{$a, "A_ARTIST"};
    $z = $autotags{$b, "A_ALBUM"};
    if ($x eq "" || $y eq "") {
	$title = $title . "<br><em>&nbsp;" . $i;
    } else {
	$title = $title . "<br><em>&nbsp;<a href=\"/rfm/tunesbyartist" . $x . ".html#" . $y . "\">" . $i . "</a>";
    }
    $i = lookuptag($b, "N=");
    if ($i eq "") {
	$i = $b;
	$i =~ s/\/$//;
	$i =~ s/^.*\///;
    }
    if ($x eq "" || $z eq "") {
	$title = $title . " / " . $i;
    } else {
	$title = $title . " / <a href=\"/rfm/tunesbyartist" . $x . ".html#" . $z . "\">" . $i . "</a>";
    }
    $title = $title . "</em>";
    return $title;
}

sub friendlyalbumtitle {
    my ($title) = "";
    my ($b) = @_;
    my ($a) = $b;
    my ($i) = rindex($a, "/");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    my ($x) = $autotags{$a, "H_ARTIST"};
    my ($y) = $autotags{$a, "A_ARTIST"};
    my ($z) = $autotags{$b, "A_ALBUM"};
    $i = lookuptag($b, "N=");
    if ($x eq "" || $z eq "") {
	$title = $i;
    } else {
	$title = "<a href=\"/rfm/tunesbyartist" . $x . ".html#" . $z . "\">" . $i . "</a>";
    }
    $i = lookuptag($a, "N=");
    if ($i ne "") {
	if ($x eq "" || $y eq "") {
	    $title = $title . " - " . $i;
	} else {
	    $title = $title . " - <a href=\"/rfm/tunesbyartist" . $x . ".html#" . $y . "\">" . $i . "</a>";
	}
    }
    return $title;
}

sub gettime {
    my ($i) = lookuptag(@_, "T=");
    if ($i eq "") {
	$i = "?";
    }
    $i = "(" . $i . ")";
    return $i;
}

$mydomain=`/bin/hostname`;
chop $mydomain;
$mydomain =~ s/^[^.]*.//;

print "Content-type: text/html\n";
print "\n";
print "<html>\n";
print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
print "<meta http-equiv=\"refresh\" CONTENT=\"60\">\n";
print "<head>\n";
print "<title>" . $ENV{BANNER_STRING} . " Whuzzon</title>\n";
print "</head>\n";
open(I, $tunebot_root . "/html/bodypart.html.head");
while ($line = <I>) {
    print $line;
}
close(I);

print "<table width=90% align=center cellpadding=0 cellspacing=0>\n";
print "<tr><td colspan=3 align=center><font size=+1><b>Now Playing</b></font></td></tr>\n";
$status = lookuptag($q_directory . "/nowplaying", "STATUS=");
if ($status ne "") {
    print "<tr><td></td><td><b> $status </b></td></tr>\n";
}
$path = lookuptag($q_directory . "/nowplaying", "Q=");
if ($path ne "") {
    $req = lookuptag($q_directory . "/nowplaying", "SRC=");
    if ($req eq "REQ") {
	$req = " <img src=\"/rfm/request.gif\">";
	$host = lookuptag($q_directory . "/nowplaying", "HOSTNAME=");
	if (!($host =~ /^[0-9]/)) {
	    $hdomain = $host;
	    $hdomain =~ s/^[^.]*.//;
	    if ($hdomain eq $mydomain) {
		$host =~ s/\..*//;
	    }
	}
    } else {
	$req = "";
	$host = "";
    }
    @a = stat $q_directory . "/nowplaying";
    $elaps = time() - $a[9];
    $elaps = sprintf "%d:%02d", $elaps / 60, $elaps % 60;
    $title = friendlytitle($path);
    $time = gettime($path);
    print "<tr>\n";
    print "<td width=10%><a href=/cgi-bin/tunefeedback.cgi?UP=$path><img src=/rfm/thumbsup.gif border=0 alt=\"Thumbs-Up\"></a>\n";
    print "<a href=/cgi-bin/tunefeedback.cgi?DOWN=$path><img src=/rfm/thumbsdown.gif border=0 alt=\"Thumbs-Down\"></a><br>+ $elaps </td>\n";
    print "<td width=60%>$title</td>\n";
    print "<td><a href=\"/cgi-bin/abouttrack.cgi?$path\">$time</a>$req $host</td>\n";
    print "</tr>\n";
}

sub numeric { $a <=> $b; }

opendir(D, $q_directory);
@qfs = ();
foreach $i (sort numeric readdir(D)) {
    if ($i =~ /^[0-9]/) {
	@qfs = (@qfs, $i);
    }
}
closedir(D);
if ($#qfs >= 0) {
    print "<tr><td colspan=3 align=center><font size=+1><b>Requests <img src=\"/rfm/request.gif\"></b></font></td></tr>\n";

} else {
    $path = lookuptag($q_directory . "/upnext", "Q=");
    if ($path ne "") {
	print "<tr><td colspan=3 align=center><font size=+1><b>Up Next</b></font></td></tr>\n";
	$req = "";
	$host = "";
	$title = friendlytitle($path);
	$time = gettime($path);
	print "<tr><td width=10%>";
	print "<a href=/cgi-bin/tunewhack.cgi?upnext><img src=/rfm/skull.gif border=0 alt=\"Whack\"></a></td>\n";
	print "<td width=60%>$title</td>\n";
	print "<td><a href=\"/cgi-bin/abouttrack.cgi?$path\">$time</a></td>\n";
	print "</tr>\n";
    }
}
$n = 1;
foreach $i (@qfs) {
    if ($i =~ /^[0-9]/) {
	$type = lookuptag($q_directory . "/" . $i, "TYPE=");
	$path = lookuptag($q_directory . "/" . $i, "Q=");
	$host = lookuptag($q_directory . "/" . $i, "HOSTNAME=");
	$at = lookuptag($q_directory . "/" . $i, "AT=");
	$dedic = lookuptag($q_directory . "/" . $i, "DEDICATION=");
	if ($dedic ne "") {
	    $dedic = "<br><font color=gold>" . $dedic . "</font>";
	}
	if (!($host =~ /^[0-9]/)) {
	    $hdomain = $host;
	    $hdomain =~ s/^[^.]*.//;
	    if ($hdomain eq $mydomain) {
		$host =~ s/\..*//;
	    }
	}
	if ($host ne "") {
	    $host = "<a href=\"/cgi-bin/tuneded.cgi?" . $i . "\">" . $host . "</a>";
	}
	if ($at ne "") {
	    $reqtime = substr($at,0,4) . "/" . substr($at,4,2) . "/" . substr($at,6,2) . " " . substr($at,8,2) . ":" . substr($at,10,2);
	    $reqtime = "<em>~ " . nicetime($reqtime) . "</em>";
	} else {
	    $reqtime = "";
	}
	if ($type eq "ALBUM") {
	    $title = friendlyalbumtitle($path);
	    $time = lookuptag($q_directory . "/" . $i, "T=");
	    $trk = lookuptag($q_directory . "/" . $i, "CTRACK=");
	    $trks = lookuptag($q_directory . "/" . $i, "TRACKS=");
	    print "<tr><td width=10%>\n";
	    if ($random_from_q == 0) {
		print "<font size=+1><b>$n.</b></font>\n";
	    }
	    print "<a href=/cgi-bin/tunewhack.cgi?$i><img src=/rfm/skull.gif border=0 alt=\"Whack\"></a></td>\n";
	    print "<td width=60%><font size=+1><b>$title</b></font>\n";
	    if ($trks eq "") {
		if ($trk ne "") {
		    print "<br>&nbsp; <em>(playing track $trk)</em>";
		}
	    } else {
		print "<br>&nbsp; <em>";
		foreach $j (sort numeric (split /,/, $trks)) {
		    if ($j >= $trk) {
			if ($j == $trk) {
			    print " <b><u>$j</u></b>";
			} else {
			    print " <b> $j </b>";
			}
		    } else {
			print " $j";
		    }
		}
		print "</em>";
	    }
	    print "</td>\n";
	    print "<td>($time) $host $reqtime $dedic</td>\n";
	    print "</tr>\n";
	} else {
	    $title = friendlytitle($path);
	    $time = gettime($path);
	    print "<tr><td width=10%>\n";
	    if ($random_from_q == 0) {
		print "$n.\n";
	    }
	    print "<a href=/cgi-bin/tunewhack.cgi?$i><img src=/rfm/skull.gif border=0 alt=\"Whack\"></a></td>\n";
	    print "<td width=60%>$title</td>\n";
	    print "<td><a href=\"/cgi-bin/abouttrack.cgi?$path\">$time</a> $host $reqtime $dedic</td>\n";
	    print "</tr>\n";
	}
	$n++;
    }
}

print "<tr><td colspan=3 align=center><font size=+1><b>Recent Tracks</b></font></td></tr>";

@paths = ();
open(I, "/usr/bin/tail -$how_many " . $q_directory . "/history" . "|");
while ($line = <I>) {
    chop $line;
    @lines = (@lines, $line);
}
foreach $line (reverse @lines) {
    @raw = split(" ", $line);
    $path = @raw[0];
    $title = friendlytitle($path);
    $time = gettime($path);
    $pt = @raw[1];
    $playtime = substr($pt,0,4) . "/" . substr($pt,4,2) . "/" . substr($pt,6,2) . " " . substr($pt,8,2) . ":" . substr($pt,10,2);
    $playtime = "<em>~ " . nicetime($playtime) . "</em>";
    if ($line =~ /REQ/) {
	$req = " <img src=\"/rfm/request.gif\">";
	($host = $line) =~ s/.*HOSTNAME=([^ ]*).*/$1/;
	if (!($host =~ /^[0-9]/)) {
	    $hdomain = $host;
	    $hdomain =~ s/^[^.]*.//;
	    if ($hdomain eq $mydomain) {
		$host =~ s/\..*//;
	    }
	}
    } else {
	$req = "";
	$host = "";
    }
    print "<tr>\n";
    print "<td width=10%><a href=/cgi-bin/tunefeedback.cgi?UP=$path><img src=/rfm/thumbsup.gif border=0 alt=\"Thumbs-Up\"></a>\n";
    print "<a href=/cgi-bin/tunefeedback.cgi?DOWN=$path><img src=/rfm/thumbsdown.gif border=0 alt=\"Thumbs-Down\"></a></td>\n";
    print "<td width=60%>$title</td>\n";
    print "<td><a href=\"/cgi-bin/abouttrack.cgi?$path\">$time</a>$req $host $playtime</td>\n";
    print "</tr>\n";
}
close(I);

print "</table>\n";
print "<center>\n";
print "<a href=\"/cgi-bin/tuneq.cgi?" . $how_many * 2 . "\">show like more history</a>";
print "</center>\n";
print "<p>\n";
print "<center>\n";
print "<b>Legend...</b>\n";
print "<img src=/rfm/thumbsup.gif alt=\"Thumbs-Up\">\n";
print "Dank\n";
print "...\n";
print "<img src=/rfm/thumbsdown.gif alt=\"Thumbs-Down\">\n";
print "Schwag\n";
print "...\n";
print "<img src=/rfm/skull.gif alt=\"Whack\">\n";
print "I take it back\n";
print "...\n";
print "<img src=/rfm/request.gif alt=\"Request\">\n";
print "Was requested\n";
print "</center>\n";

open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0

